
#property  copyright "Copyright ?2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Red
#property  indicator_color2  Green
#property  indicator_color3  Yellow
#property  indicator_width1  1

extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;

double     diff[], dea[], hist[];

int init()
  {

   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,diff);
   SetIndexBuffer(1,dea);
   SetIndexBuffer(2,hist);

   IndicatorShortName("macd simplified02"+FastEMA+","+SlowEMA+","+SignalSMA+")");
   SetIndexLabel(0,"diff");
   SetIndexLabel(1,"dea");
   SetIndexLabel(2,"hist");

   return(0);
  }

int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(int i=0; i<limit; i++){
//   diff[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);//using this line instead of the line below, the indicator produces output.
     diff[i]=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);//using this line instead of the line above, I can see no output in the indicator window.
   }

   for(i=0; i<limit; i++)
      dea[i]=iMAOnArray(diff,Bars,SignalSMA,0,MODE_SMA,i);

   for(i=0; i<limit; i++)
      hist[i]=diff[i]-dea[i];

   return(0);
  }
//+------------------------------------------------------------------+